/*
 *	netbug.h
 *
 */
#ifndef LIBNETBUG_H
#define LIBNETBUG_H

#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/uio.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <values.h>
#include <math.h>
#include <sys/errno.h>
#include <sys/syscall.h>
#include <stdlib.h>
#include <unistd.h>
#include <memory.h>
#include <alloca.h>
#include <sys/time.h>
#include <syscall.h>
#include <linux/net.h>
#include <time.h>

#ifdef __STDC__
#define _Proto(x) x
#define CONST const
#define POINTER void *
#define STRINGJOIN(s, t) s##t
#else
#define _Proto(x) ()
#define CONST /* empty */
#define POINTER char *
#define STRINGJOIN(s, t) s/**/t
#endif

#ifndef MAX
#define MAX(x, y) ((x) > (y) ? (x) : (y))
#endif
#ifndef MIN
#define MIN(x, y) ((x) < (y) ? (x) : (y))
#endif



#define NETBUG_NBUFS 5
#define NETBUG_BUFSIZE 8192

struct _netbug_buf {
  int fd;
  char buf[NETBUG_BUFSIZE];
  int len;
  int flags;
  struct sockaddr_in addr;
  int addrlen;
};

extern struct _netbug_buf _modlib_recvbufs[NETBUG_NBUFS],
  _netbug_sendbufs[NETBUG_NBUFS];

extern int _netbug_inited;
extern int _netbug_verbose;

extern int _netbug_recv_delay; /* uniform distribution [0..x] */
extern double _netbug_recv_dropchance;
extern double _netbug_recv_storechance;
extern double _netbug_recv_dupchance;
extern double _netbug_recv_misorderchance;
extern int _netbug_recv_maxsize;
extern int _netbug_send_delay; /* uniform distribution [0..x] */
extern double _netbug_send_dropchance;
extern double _netbug_send_storechance;
extern double _netbug_send_dupchance;
extern double _netbug_send_misorderchance;
extern int _netbug_send_maxsize;

extern int _netbug_recvd;
extern int _netbug_recv_delayed;
extern int _netbug_recv_dropped;
extern int _netbug_recv_stored;
extern int _netbug_recv_duped;
extern int _netbug_recv_misordered;
extern int _netbug_recvd_maxsize;
extern int _netbug_sent;
extern int _netbug_send_delayed;
extern int _netbug_send_dropped;
extern int _netbug_send_stored;
extern int _netbug_send_duped;
extern int _netbug_send_misordered;
extern int _netbug_sent_maxsize;

extern double _netbug_chance _Proto((void));
extern int _netbug_uniform _Proto((int upper));

extern struct _netbug_buf *_netbug_search_stored_recv_packet _Proto((int));
extern struct _netbug_buf *_netbug_search_free_recv_packet _Proto((void));
extern struct _netbug_buf *_netbug_search_stored_send_packet _Proto((int));
extern struct _netbug_buf *_netbug_search_free_send_packet _Proto((void));

extern void _netbug_init _Proto((void));
extern void _netbug_stats _Proto((void));

#endif /* LIBNETBUG_H */
