/*
 *	recvfrom.c
 *
 */

#include "netbug.h"

#if 1

#define FUNC_NAME "recvfrom"

int __libc_recvfrom(int, void *, size_t, int, struct sockaddr *, socklen_t *);
#define DO_SYSCALL(_fd, _buf, _len, _flags, _from, _fromlen) \
  __libc_recvfrom((_fd), (_buf), (_len), (_flags), (_from), (_fromlen))

#define GETSRCPORT(_fd, _a, _from, _fromlen) \
  (_a) = (struct sockaddr_in *)&_from;

#define COPY_STOREDPACKET(_stored, _ret) \
{ \
  int tmpfromlen, tmpret; \
  int* fromptr; \
  fromptr = (int*) fromlen; \
  tmpfromlen = MIN(*fromptr, (_stored)->addrlen); \
  memcpy(from, &(_stored)->addr, tmpfromlen); \
  *fromptr = tmpfromlen; \
  tmpret = MIN((_stored)->len, len); \
  memcpy(buf, (_stored)->buf, tmpret); \
  (_ret) = tmpret; \
}

int recvfrom(int fd, void *buf, size_t len, int flags, struct sockaddr *from, socklen_t *fromlen)
{

#include "recv-common.ic"

}

#else

int recvfrom(s, buf, len, flags, from, fromlen)
int s;
POINTER buf;
int len, flags;
struct sockaddr *from;
int *fromlen;
{
  int ret, tmpret, tmpfromlen;
  char *tmpbuf;
  struct sockaddr_in tmpfrom;
  int opt, optlen;
  struct _netbug_buf *stored;
  struct sockaddr_in *a;

  /* check if socket and addr are appropriate to disturb */
  opt = SOCK_STREAM;
  optlen = sizeof opt;
  if (getsockopt(s, SOL_SOCKET, SO_TYPE, (char *)&opt, &optlen))
    perror("recvfrom/getsockopt");
  tmpfrom.sin_family = AF_UNSPEC;
  tmpfromlen = sizeof tmpfrom;
  if (getsockname(s, (struct sockaddr *)&tmpfrom, &tmpfromlen))
    perror("recvfrom/getsockname");
  if (SOCK_DGRAM == opt
      && AF_INET == tmpfrom.sin_family
      /* && further checks */ ) {

    /* check if we already have a stored packet for this socket */
    if (_netbug_chance() < _netbug_recv_misorderchance
	&& NULL != (stored = _netbug_search_stored_recv_packet(s))) {
      tmpfromlen = MIN(*fromlen, stored->fromlen);
      memcpy(from, &stored->from, tmpfromlen);
      *fromlen = tmpfromlen;
      tmpret = MIN(stored->recvdlen, len);
      memcpy(buf, stored->buf, tmpret);
      ret = tmpret;
      if (_netbug_chance() > _netbug_recv_dupchance)
	stored->fd = -1;	/* remove stored packet */
      if (_netbug_verbose) {
	char *b = buf;
	a = (struct sockaddr_in *)&from;
	fprintf(stderr,
	     "recvfrom(%d, \"%c%c%c%c\", 0x%lx.%d) = %d returns stored msg\n",
		s, b[0], b[1], b[2], b[3],
		a->sin_addr.s_addr, a->sin_port, ret);
      }
      return ret;
    }
    tmpbuf = alloca(len);
    tmpfromlen = *fromlen;
tmpfromlen = DO_SYSCALL(s, tempbuf, len, flags, &tmpfrom, &tmpfromlen);
    if (_netbug_chance() < _netbug_recv_storechance
	&& tmpret < NETBUG_BUFSIZE
	&& NULL != (stored = _netbug_search_free_recv_packet(s))) {
      stored->fd = s;
      memcpy(stored->buf, tmpbuf, tmpret);
      stored->recvdlen = tmpret;
      memcpy(&stored->from, &tmpfrom, tmpfromlen);
      stored->fromlen = tmpfromlen;
    }
    if (_netbug_chance() > _netbug_recv_dropchance) {
      memcpy(buf, tmpbuf, tmpret);
      memcpy(from, &tmpfrom, tmpfromlen);
      *fromlen = tmpfromlen;
      ret = tmpret;
      if (_netbug_verbose) {
	char *b = buf;
	a = (struct sockaddr_in *)&from;
	fprintf(stderr,
	    "recvfrom(%d, \"%c%c%c%c\", 0x%lx.%d) = %d returns recvd msg\n",
	    s, b[0], b[1], b[2], b[3],
	    a->sin_addr.s_addr, a->sin_port, ret);
      }
      return ret;
    }
  }

ret=DO_SYSCALL(s,buf,len,flags,from,fromlen);
  if (_netbug_verbose) {
    char *b = buf;
    a = (struct sockaddr_in *)&from;
    fprintf(stderr,
	    "recvfrom(%d, \"%c%c%c%c\", 0x%lx.%d) = %d returns received msg\n",
	    s, b[0], b[1], b[2], b[3],
	    a->sin_addr.s_addr, a->sin_port, ret);
  }
  return ret;
}

#endif
