#include <stdio.h>
#include <stdlib.h>
#include "video.h"
#include "avformat.h"
#include "reader.h"

#define PICBUFFERSIZE 80 /* minimal 1, maximal 80, see spec */

/* globals */
int nLoopCnt;
int frameoff;
int video_y_off;

/* Prototypen fuer externe Funktionen */
extern void graceful_exit();

int decompPics(t_avfileheader *prHeader, t_rblock aVBlocks[]){
	int picCnt, check;
	for(picCnt=0; picCnt<prHeader->avformat.block_anz; ++picCnt){
		/*        		dumpPayload(aVBlocks[picCnt].payload, */
		/*        					aVBlocks[picCnt].header.video.block_size); */
		printf("frame: %d  size: %d  offset: %d\n", picCnt,
			   aVBlocks[picCnt].header.video.block_size, 
			   frameoff); 
			   
  		check = decomp_JPEG(aVBlocks[picCnt].payload, 
							aVBlocks[picCnt].header.video.block_size, 
  							frameoff); 
		frameoff += prHeader->avformat.bytes_per_block;
		/*  		printf("%d ",picCnt); */
		if(0==check){
			printf("JPEG decomp failed! filenr: %d  picnr: %d",
				   nFilenr, picCnt);
		}
	}
	return frameoff;
}

void playVideo(t_avfileheader *prHeader){
	printf("video: %d\n",video_y_off);
	show_video(video_y_off);
	video_y_off += prHeader->avformat.height;
}

void playAudio(t_avfileheader *prHeader, t_rblock *prABlock){
	play_audio_block(prABlock->payload, prHeader->avformat.audio_buffer_size);
}

void feierabend()
{
	graceful_exit();
}

void init(char *hostName, int portNr, char *movie)
{
	printf("Playing %s@%s:%d...\n",movie,hostName,portNr);
	nFilenr = 0;
	nLoopCnt = 0;
	frameoff = 0;
	video_y_off = 0;
	cstrMovieName = movie;
}


/* Die Funktion main_loop wird periodisch vom Hauptprogramm durchlaufen.     */
/* In dieser Funktion werden die Daten des Servers empfangen und bearbeitet. */
void main_loop()
{
  	char *chunk;
  	int off;
  	t_avfileheader *prHeader;
  	t_rblock *aVBlocks;
  	t_rblock *prABlock;
  	off = 0;

  	if(openNextFile()==FALSE){
  		feierabend();
		exit(1);
  	}

	/*    	printf("starting with file: %d\n",nFilenr); */
  	chunk = readData();
  	off = readHeader(chunk, &prHeader);
	if(0==nLoopCnt){ 
		printf("av init, PICBUFFERSIZE: %d\n",PICBUFFERSIZE);  
		init_audio_video(&(prHeader->avformat), PICBUFFERSIZE); 
		dumpHeader(prHeader);
		printf("initialized.\n");  
	}  
	/*  	printf("read video, off: 0x%x (%d)  blockcnt: %d\n",off,off, */
	/*  		   prHeader->avformat.block_anz); */
	off = readVBlocks(off, chunk, prHeader->avformat.block_anz, &aVBlocks);
	/*  	printf("video read, off: 0x%x (%d)\n",off,off);  */
	off = readABlock(off, chunk, &prABlock,  
  					 prHeader->avformat.audio_buffer_size); 
	/*  	printf("audio read, off: 0x%x (%d)\n",off,off);  */


	decompPics(prHeader, aVBlocks); 
	if(nLoopCnt%2==0) {
		playAudio(prHeader, prABlock); 
		playVideo(prHeader); 
	}
  	++nFilenr;
  	++nLoopCnt;
}

/* vi:set tabstop=4 shiftwidth=4 noexpandtab: */
